clear;
fprintf('\n');
disp('--------------------------------START--------------------------------');
disp('This demo shows how we can use this program.');

dataset='sorliedataorig'; % Dataset
func='minlip'; % Model function
tunemethod='linesearch'; % Tune method
tunepar={-10,10,1,0.1}; % Tune parameters (serach range/initial values)
testmethod='CV'; % Test method
testpar={3}; % Test parameters

% Start
tic

% Load the selected database
load(dataset);
model=buildmodel(func,X,Y,delta);

n=size(X,1);
ntrain=ceil(n/3*2);
ntest=n-ntrain;

% Seperate it into train set and test set
indtrain=ntest+1:n;
indtest=1:ntest;
[trainmodel,testmodel]=seperatemodel(model,indtrain,indtest);

% Change the signs if needed
if strcmp(func,'model2p') || strcmp(func,'minlipp')
    [trainmodel.X, testmodel.X]=changesign(trainmodel,testmodel.X);
end

% Tune the trainmodel
trainmodel.gam=tune(trainmodel,tunemethod,tunepar,testmethod,testpar);
% Get w based on training set using the tuned parameters
w=feval(func,trainmodel);

%Calculate the c-index on both sets
ctest=cindex(testmodel.X*w,testmodel.Y,testmodel.delta)
ctrain=cindex(trainmodel.X*w,trainmodel.Y,trainmodel.delta)
lrtest=getlogrank(testmodel.Y,testmodel.delta,testmodel.X*w)
lrtrain=getlogrank(trainmodel.Y,trainmodel.delta,trainmodel.X*w)
hrtest=gethr(testmodel.Y,testmodel.delta,-testmodel.X*w)
hrtrain=gethr(trainmodel.Y,trainmodel.delta,-trainmodel.X*w)
disp('Time cost:')
toc

disp('---------------------------------END---------------------------------');
fprintf('\n');